<template>
  <div class="app container">
    <h1 class="head-2 text-center">Mindmap</h1>

    <div
      v-if="nodeTree"
      class="node__tree-wrapper"
    >
      <button
        class="btn--main removeNodes"
        title="Clear data"
        @click.stop="clearNodeTree"
      >
        <img src="./assets/images/close-outline.svg" alt="clear data">
      </button>

      <ul
        class="node__tree-list"
      >
        <NodeElement
          v-for="(nodeObj, di) in nodeTree.data"
          isParent
          :data="nodeObj"
          :lvlOfNested="0"
          :key="`${di} ${nodeObj.title}`"
        />
      </ul>
    </div>

    <div
      v-else
      class="node__tree-wrapper--flex"  
    >
      <button
        class="btn--main"
        @click="createInitialData"
      >Start from scratch</button>

      <DataLoader />
    </div>
    
    <JsonPreview v-if="nodeTree" />
  </div>
</template>

<script>
  import {
    SET_NODE_TREE,
    CLEAR_NODE_TREE
  } from './store/node/mutations'

  import NodeElement from './components/NodeElement'
  import JsonPreview from './components/JsonPreview'
  import DataLoader from './components/DataLoader'

  export default {
    name: 'App',
    components: {
      NodeElement,
      JsonPreview,
      DataLoader
    },

    computed: {
      nodeTree() {
        return this.$store.getters.nodeTree
      }
    },

    methods: {
      createInitialData() {
        const initialTitle = prompt('Enter a title for initial node')
        
        if(initialTitle) {
          const initialData = {
            data: [
              {
                title: initialTitle
              }
            ]
          }

          this.$store.commit(SET_NODE_TREE, initialData)
        }
      },

      clearNodeTree() {
        this.$store.commit(CLEAR_NODE_TREE)
      }
    }
  }
</script>

<style lang="scss">
  :root {
    --color-white: #fdfdfd;
    --color-teal: #057d7e;
    --color-red: #eb001e;
    --color-grey: #313131;
    --color-light-grey: #dadada;

    // button
    --button-background-color-1: var(--color-teal);
    --button-background-color-2: var(--color-white);
    --button-background-color-3: var(--color-red);
    --button-text-color-1: var(--color-white);
    --button-text-color-2: var(--color-grey);

    // border
    --border-color-1: var(--color-grey-light);
    --border-color-2: var(--color-teal);

    // message
    --message-text-color-1: var(--color-red);
    --message-text-color-2: var(--color-teal);
    --message-text-color-3: var(--color-grey);

    // json-preview
    --json-background-color: var(--color-grey);
    --json-text-color: var(--color-white);
  }

  * {
    box-sizing: border-box;
  }

  body {
    font: 400 16px / 1 'Open Sans', sans-serif;
  }

  .container {
    width: 100%;
    max-width: 1140px;
    margin: 0 auto;
    padding: 0 1rem;
  }

  .head-2 {
    font-weight: 700;
    font-size: 2.2rem;
  }

  .head-7 {
    font-weight: 700;
    font-size: .7rem;
  }

  .text-center {
    text-align: center;
  }

  .btn--main {
    padding: 1rem;
    color: var(--button-text-color-1);
    font-weight: 600;
    background-color: var(--button-background-color-1);
    border: none;
    text-decoration: none;
    text-transform: uppercase;
    transition: opacity .3s;
    outline: none;
    user-select: none;
    cursor: pointer;

    &:hover {
      opacity: .8;
    }
  }

  .btn--second {
    color: var(--button-text-color-2);
    font-weight: 600;
    background-color: var(--button-background-color-2);
    border: none;
    text-decoration: none;
    text-transform: uppercase;
    transition: opacity .3s;
    outline: none;
    user-select: none;
    cursor: pointer;

    &:hover {
      opacity: .8;
    }
  }

  .btn--error {
    color: var(--button-text-color-1);
    font-weight: 600;
    background-color: var(--button-background-color-3);
    border: none;
    text-decoration: none;
    text-transform: uppercase;
    transition: opacity .3s;
    outline: none;
    user-select: none;
    cursor: pointer;

    &:hover {
      opacity: .8;
    }
  }

  .app {
    margin: 1rem auto
  }

  .node__tree-wrapper {
    position: relative;
    display: flex;
    border: 4px solid var(--border-color-2);
    max-height: 450px;

    .removeNodes {
      position: absolute;
      top: 0;
      right: 0;
      width: 25px;
      height: 25px;
      padding: .1rem;
      display: flex;
      align-items: center;
      z-index: 2;
    }

    .node__tree-list {
      width: 100%;
      max-width: 100%;
      margin: 0;
      padding: 1.8rem 1rem;
      list-style: none;
      overflow: auto;

      > li {
        margin-bottom: 1rem;

        &:last-child {
          margin-bottom: 0;
        }
      }
    }
  }

  .node__tree-wrapper--flex {
    padding: 1rem;
    display: flex;
    align-items: center;
    justify-content: center;
    flex-wrap: wrap;
    border: 4px solid var(--border-color-2);
    max-height: 450px;

    .btn--main {
      margin: .5rem;
      min-width: 210px;
    }
  }
</style>
